IF EXISTS (SELECT * FROM dbo.SysObjects WHERE id = object_id(N'dbo.AUDIT_upd_Reservations') AND OBJECTPROPERTY(id, N'IsTrigger') = 1) DROP TRIGGER dbo.AUDIT_upd_Reservations 
GO
CREATE TRIGGER [dbo].[AUDIT_upd_Reservations]
ON [dbo].[Reservations] FOR UPDATE NOT FOR REPLICATION AS
BEGIN
	

	DECLARE 
		@IDENTITY_SAVE			varchar(50),
		@AUDIT_LOG_TRANSACTION_ID	Int,
		@PRIM_KEY			nvarchar(4000),
		@Inserted	    		bit,
 		@ROWS_COUNT				int,
		@FK_UserIdNumber INT,
		@FK_CashBox INT,
		@ProgramPart SMALLINT,
		@TerminalName VARCHAR(50),
		@SystemDateStr VARCHAR(8),
		@SystemDateTime DATETIME
 
	SET NOCOUNT ON

	Select @ROWS_COUNT=count(*) from inserted
	SET @IDENTITY_SAVE = CAST(IsNull(@@IDENTITY,1) AS varchar(50))

    SELECT TOP 1 @FK_UserIdNumber = FK_UserIdNumber,
	@FK_CashBox = FK_CashBox,
	@ProgramPart = ProgramPart,
	@TerminalName = TerminalName
	FROM PersonnelLogInfo WITH (NOLOCK)
	WHERE spid = @@spid 
	ORDER BY CreateDate DESC

	IF ISNULL(@FK_UserIdNumber, 0) = 0
	  SET @FK_UserIdNumber = 1
	IF ISNULL(@FK_CashBox, -1) <= 0
	  SET @FK_CashBox = -1
	IF ISNULL(@ProgramPart, -1) <= 0
	  SET @ProgramPart = 14 -- ppUnknown from SystemAll
	IF ISNULL(@TerminalName, '') = ''
	  SET @TerminalName = 'Unknown'

    SELECT @SystemDateStr = SystemDate FROM System WITH (NOLOCK) WHERE Number = 1
    SET @SystemDateTime = CONVERT(DATETIME, @SystemDateStr + ' ' + CONVERT(CHAR(8), CURRENT_TIMESTAMP, 108))

	INSERT INTO dbo.AUDIT_LOG_TRANSACTIONS 
	(
		TABLE_NAME,
		TABLE_SCHEMA,
		AUDIT_ACTION_ID,
		HOST_NAME,
		APP_NAME,
		MODIFIED_BY,
		MODIFIED_DATE,
		AFFECTED_ROWS,
		FK_UserIdNumber,
		FK_CashBox,
		ProgramPart,
		TerminalName,
		RealDateTime
	)
	values(
		'Reservations',
		'dbo',
		1,	--	ACTION ID For UPDATE
		CASE 
		  WHEN LEN(HOST_NAME()) < 1 THEN ' '
		  ELSE HOST_NAME()
		END,
		CASE 
		  WHEN LEN(APP_NAME()) < 1 THEN ' '
		  ELSE APP_NAME()
		END,
		SUSER_SNAME(),
		@SystemDateTime,
		@ROWS_COUNT,
		@FK_UserIdNumber,
		@FK_CashBox,
		@ProgramPart,
		@TerminalName,
		GETDATE()
	)	
	
	Set @AUDIT_LOG_TRANSACTION_ID = SCOPE_IDENTITY()
		
	SET @Inserted = 0
	
	If UPDATE([Status])
	BEGIN
    
		INSERT
		INTO dbo.AUDIT_LOG_DATA 
		(
			AUDIT_LOG_TRANSACTION_ID,
			PRIMARY_KEY_DATA,
			COL_NAME,
			OLD_VALUE_LONG,
			NEW_VALUE_LONG,
			DATA_TYPE
			, KEY1, KEY2
		)
		SELECT
			@AUDIT_LOG_TRANSACTION_ID,
		    convert(nvarchar(1500), IsNull('[ReferenceNumber]='+CONVERT(nvarchar(4000), IsNull(OLD.[ReferenceNumber], NEW.[ReferenceNumber]), 0), '[ReferenceNumber] Is Null')+' AND '+IsNull('[GuestNumber]='+CONVERT(nvarchar(4000), IsNull(OLD.[GuestNumber], NEW.[GuestNumber]), 0), '[GuestNumber] Is Null')),
		    'Status',
			CONVERT(nvarchar(4000), OLD.[Status], 0),
			CONVERT(nvarchar(4000), NEW.[Status], 0),
			'A'
			, IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[ReferenceNumber], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[ReferenceNumber], 0))), IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[GuestNumber], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[GuestNumber], 0)))
			
		FROM deleted OLD Inner Join inserted NEW On 
			(CONVERT(nvarchar(4000), NEW.[ReferenceNumber], 0)=CONVERT(nvarchar(4000), OLD.[ReferenceNumber], 0) or (NEW.[ReferenceNumber] Is Null and OLD.[ReferenceNumber] Is Null)) AND (CONVERT(nvarchar(4000), NEW.[GuestNumber], 0)=CONVERT(nvarchar(4000), OLD.[GuestNumber], 0) or (NEW.[GuestNumber] Is Null and OLD.[GuestNumber] Is Null))
			where (
			
			
				(
					NEW.[Status] <>
					OLD.[Status]
				) Or
			
				(
					NEW.[Status] Is Null And
					OLD.[Status] Is Not Null
				) Or
				(
					NEW.[Status] Is Not Null And
					OLD.[Status] Is Null
				)
				)
        
		SET @Inserted = CASE WHEN @@ROWCOUNT > 0 Then 1 Else @Inserted End
	END
	
	If UPDATE([TotalPrice])
	BEGIN
    
		INSERT
		INTO dbo.AUDIT_LOG_DATA 
		(
			AUDIT_LOG_TRANSACTION_ID,
			PRIMARY_KEY_DATA,
			COL_NAME,
			OLD_VALUE_LONG,
			NEW_VALUE_LONG,
			DATA_TYPE
			, KEY1, KEY2
		)
		SELECT
			@AUDIT_LOG_TRANSACTION_ID,
		    convert(nvarchar(1500), IsNull('[ReferenceNumber]='+CONVERT(nvarchar(4000), IsNull(OLD.[ReferenceNumber], NEW.[ReferenceNumber]), 0), '[ReferenceNumber] Is Null')+' AND '+IsNull('[GuestNumber]='+CONVERT(nvarchar(4000), IsNull(OLD.[GuestNumber], NEW.[GuestNumber]), 0), '[GuestNumber] Is Null')),
		    'TotalPrice',
			CONVERT(nvarchar(4000), OLD.[TotalPrice], 2),
			CONVERT(nvarchar(4000), NEW.[TotalPrice], 2),
			'A'
			, IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[ReferenceNumber], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[ReferenceNumber], 0))), IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[GuestNumber], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[GuestNumber], 0)))
			
		FROM deleted OLD Inner Join inserted NEW On 
			(CONVERT(nvarchar(4000), NEW.[ReferenceNumber], 0)=CONVERT(nvarchar(4000), OLD.[ReferenceNumber], 0) or (NEW.[ReferenceNumber] Is Null and OLD.[ReferenceNumber] Is Null)) AND (CONVERT(nvarchar(4000), NEW.[GuestNumber], 0)=CONVERT(nvarchar(4000), OLD.[GuestNumber], 0) or (NEW.[GuestNumber] Is Null and OLD.[GuestNumber] Is Null))
			where (
			
			
				(
					NEW.[TotalPrice] <>
					OLD.[TotalPrice]
				) Or
			
				(
					NEW.[TotalPrice] Is Null And
					OLD.[TotalPrice] Is Not Null
				) Or
				(
					NEW.[TotalPrice] Is Not Null And
					OLD.[TotalPrice] Is Null
				)
				)
        
		SET @Inserted = CASE WHEN @@ROWCOUNT > 0 Then 1 Else @Inserted End
	END
	
	If UPDATE([TotalPrice1])
	BEGIN
    
		INSERT
		INTO dbo.AUDIT_LOG_DATA 
		(
			AUDIT_LOG_TRANSACTION_ID,
			PRIMARY_KEY_DATA,
			COL_NAME,
			OLD_VALUE_LONG,
			NEW_VALUE_LONG,
			DATA_TYPE
			, KEY1, KEY2
		)
		SELECT
			@AUDIT_LOG_TRANSACTION_ID,
		    convert(nvarchar(1500), IsNull('[ReferenceNumber]='+CONVERT(nvarchar(4000), IsNull(OLD.[ReferenceNumber], NEW.[ReferenceNumber]), 0), '[ReferenceNumber] Is Null')+' AND '+IsNull('[GuestNumber]='+CONVERT(nvarchar(4000), IsNull(OLD.[GuestNumber], NEW.[GuestNumber]), 0), '[GuestNumber] Is Null')),
		    'TotalPrice1',
			CONVERT(nvarchar(4000), OLD.[TotalPrice1], 2),
			CONVERT(nvarchar(4000), NEW.[TotalPrice1], 2),
			'A'
			, IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[ReferenceNumber], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[ReferenceNumber], 0))), IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[GuestNumber], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[GuestNumber], 0)))
			
		FROM deleted OLD Inner Join inserted NEW On 
			(CONVERT(nvarchar(4000), NEW.[ReferenceNumber], 0)=CONVERT(nvarchar(4000), OLD.[ReferenceNumber], 0) or (NEW.[ReferenceNumber] Is Null and OLD.[ReferenceNumber] Is Null)) AND (CONVERT(nvarchar(4000), NEW.[GuestNumber], 0)=CONVERT(nvarchar(4000), OLD.[GuestNumber], 0) or (NEW.[GuestNumber] Is Null and OLD.[GuestNumber] Is Null))
			where (
			
			
				(
					NEW.[TotalPrice1] <>
					OLD.[TotalPrice1]
				) Or
			
				(
					NEW.[TotalPrice1] Is Null And
					OLD.[TotalPrice1] Is Not Null
				) Or
				(
					NEW.[TotalPrice1] Is Not Null And
					OLD.[TotalPrice1] Is Null
				)
				)
        
		SET @Inserted = CASE WHEN @@ROWCOUNT > 0 Then 1 Else @Inserted End
	END
	
	If UPDATE([TotalPrice2])
	BEGIN
    
		INSERT
		INTO dbo.AUDIT_LOG_DATA 
		(
			AUDIT_LOG_TRANSACTION_ID,
			PRIMARY_KEY_DATA,
			COL_NAME,
			OLD_VALUE_LONG,
			NEW_VALUE_LONG,
			DATA_TYPE
			, KEY1, KEY2
		)
		SELECT
			@AUDIT_LOG_TRANSACTION_ID,
		    convert(nvarchar(1500), IsNull('[ReferenceNumber]='+CONVERT(nvarchar(4000), IsNull(OLD.[ReferenceNumber], NEW.[ReferenceNumber]), 0), '[ReferenceNumber] Is Null')+' AND '+IsNull('[GuestNumber]='+CONVERT(nvarchar(4000), IsNull(OLD.[GuestNumber], NEW.[GuestNumber]), 0), '[GuestNumber] Is Null')),
		    'TotalPrice2',
			CONVERT(nvarchar(4000), OLD.[TotalPrice2], 2),
			CONVERT(nvarchar(4000), NEW.[TotalPrice2], 2),
			'A'
			, IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[ReferenceNumber], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[ReferenceNumber], 0))), IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[GuestNumber], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[GuestNumber], 0)))
			
		FROM deleted OLD Inner Join inserted NEW On 
			(CONVERT(nvarchar(4000), NEW.[ReferenceNumber], 0)=CONVERT(nvarchar(4000), OLD.[ReferenceNumber], 0) or (NEW.[ReferenceNumber] Is Null and OLD.[ReferenceNumber] Is Null)) AND (CONVERT(nvarchar(4000), NEW.[GuestNumber], 0)=CONVERT(nvarchar(4000), OLD.[GuestNumber], 0) or (NEW.[GuestNumber] Is Null and OLD.[GuestNumber] Is Null))
			where (
			
			
				(
					NEW.[TotalPrice2] <>
					OLD.[TotalPrice2]
				) Or
			
				(
					NEW.[TotalPrice2] Is Null And
					OLD.[TotalPrice2] Is Not Null
				) Or
				(
					NEW.[TotalPrice2] Is Not Null And
					OLD.[TotalPrice2] Is Null
				)
				)
        
		SET @Inserted = CASE WHEN @@ROWCOUNT > 0 Then 1 Else @Inserted End
	END
	
	If UPDATE([TotalPrice3])
	BEGIN
    
		INSERT
		INTO dbo.AUDIT_LOG_DATA 
		(
			AUDIT_LOG_TRANSACTION_ID,
			PRIMARY_KEY_DATA,
			COL_NAME,
			OLD_VALUE_LONG,
			NEW_VALUE_LONG,
			DATA_TYPE
			, KEY1, KEY2
		)
		SELECT
			@AUDIT_LOG_TRANSACTION_ID,
		    convert(nvarchar(1500), IsNull('[ReferenceNumber]='+CONVERT(nvarchar(4000), IsNull(OLD.[ReferenceNumber], NEW.[ReferenceNumber]), 0), '[ReferenceNumber] Is Null')+' AND '+IsNull('[GuestNumber]='+CONVERT(nvarchar(4000), IsNull(OLD.[GuestNumber], NEW.[GuestNumber]), 0), '[GuestNumber] Is Null')),
		    'TotalPrice3',
			CONVERT(nvarchar(4000), OLD.[TotalPrice3], 2),
			CONVERT(nvarchar(4000), NEW.[TotalPrice3], 2),
			'A'
			, IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[ReferenceNumber], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[ReferenceNumber], 0))), IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[GuestNumber], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[GuestNumber], 0)))
			
		FROM deleted OLD Inner Join inserted NEW On 
			(CONVERT(nvarchar(4000), NEW.[ReferenceNumber], 0)=CONVERT(nvarchar(4000), OLD.[ReferenceNumber], 0) or (NEW.[ReferenceNumber] Is Null and OLD.[ReferenceNumber] Is Null)) AND (CONVERT(nvarchar(4000), NEW.[GuestNumber], 0)=CONVERT(nvarchar(4000), OLD.[GuestNumber], 0) or (NEW.[GuestNumber] Is Null and OLD.[GuestNumber] Is Null))
			where (
			
			
				(
					NEW.[TotalPrice3] <>
					OLD.[TotalPrice3]
				) Or
			
				(
					NEW.[TotalPrice3] Is Null And
					OLD.[TotalPrice3] Is Not Null
				) Or
				(
					NEW.[TotalPrice3] Is Not Null And
					OLD.[TotalPrice3] Is Null
				)
				)
        
		SET @Inserted = CASE WHEN @@ROWCOUNT > 0 Then 1 Else @Inserted End
	END
	
	If UPDATE([TotalPrice4])
	BEGIN
    
		INSERT
		INTO dbo.AUDIT_LOG_DATA 
		(
			AUDIT_LOG_TRANSACTION_ID,
			PRIMARY_KEY_DATA,
			COL_NAME,
			OLD_VALUE_LONG,
			NEW_VALUE_LONG,
			DATA_TYPE
			, KEY1, KEY2
		)
		SELECT
			@AUDIT_LOG_TRANSACTION_ID,
		    convert(nvarchar(1500), IsNull('[ReferenceNumber]='+CONVERT(nvarchar(4000), IsNull(OLD.[ReferenceNumber], NEW.[ReferenceNumber]), 0), '[ReferenceNumber] Is Null')+' AND '+IsNull('[GuestNumber]='+CONVERT(nvarchar(4000), IsNull(OLD.[GuestNumber], NEW.[GuestNumber]), 0), '[GuestNumber] Is Null')),
		    'TotalPrice4',
			CONVERT(nvarchar(4000), OLD.[TotalPrice4], 2),
			CONVERT(nvarchar(4000), NEW.[TotalPrice4], 2),
			'A'
			, IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[ReferenceNumber], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[ReferenceNumber], 0))), IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[GuestNumber], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[GuestNumber], 0)))
			
		FROM deleted OLD Inner Join inserted NEW On 
			(CONVERT(nvarchar(4000), NEW.[ReferenceNumber], 0)=CONVERT(nvarchar(4000), OLD.[ReferenceNumber], 0) or (NEW.[ReferenceNumber] Is Null and OLD.[ReferenceNumber] Is Null)) AND (CONVERT(nvarchar(4000), NEW.[GuestNumber], 0)=CONVERT(nvarchar(4000), OLD.[GuestNumber], 0) or (NEW.[GuestNumber] Is Null and OLD.[GuestNumber] Is Null))
			where (
			
			
				(
					NEW.[TotalPrice4] <>
					OLD.[TotalPrice4]
				) Or
			
				(
					NEW.[TotalPrice4] Is Null And
					OLD.[TotalPrice4] Is Not Null
				) Or
				(
					NEW.[TotalPrice4] Is Not Null And
					OLD.[TotalPrice4] Is Null
				)
				)
        
		SET @Inserted = CASE WHEN @@ROWCOUNT > 0 Then 1 Else @Inserted End
	END
	
	-- Watch
	
	-- Lookup
	
	IF @Inserted = 0
	BEGIN
		DELETE FROM dbo.AUDIT_LOG_TRANSACTIONS WHERE AUDIT_LOG_TRANSACTION_ID = @AUDIT_LOG_TRANSACTION_ID
	END
	-- Restore @@IDENTITY Value  
    DECLARE @maxprec AS varchar(2)
    SET @maxprec=CAST(@@MAX_PRECISION as varchar(2))
    EXEC('SELECT IDENTITY(decimal('+@maxprec+',0),'+@IDENTITY_SAVE+',1) id INTO #tmp')
End
